#!/usr/bin/perl

my($mytime) = time();
my($t1) = time();
my($t2);
my($version) = "1.1i";

&parseForm;

$subDir = 1;
$listDirs = 0;

if ($FORM{'log'} ne "") { &writeLog; }
if ($FORM{'base'} eq "") { myError( "base not passed." ); }
if ($FORM{'rbase'} eq "") { myError("rbase not passed." );  }
if ($FORM{'sortmode'} eq "") { $FORM{'sortmode'} = '1' };
if ($FORM{'ndays'} eq "") { $FORM{'ndays'} = '7' };
if ($FORM{'dirs'} ne "") {
	@directories = split( /;/,$FORM{'dirs'});
	$listDirs = 1;
	$FORM{'dosub'} = "no";
}
if (lc($FORM{'dosub'}) eq "no") { $subDir = 0; }
	
$mytime = $mytime - ($FORM{'ndays'} * 86400 );

&htmlTop;

if ($listDirs > 0) { 
	foreach $dir (@directories) {
		&checkFiles($FORM{'base'}."$dir");
	}
} else {
	&checkFiles($FORM{'base'});
}


if ($FORM{'sortmode'} eq '1') {
	foreach $key ( sort ( keys( %DATA ) ) ) { 
		printDetails( $DATA{$key} );
	}
} elsif ($FORM{'sortmode'} eq '2') {
	foreach $key ( sort { $b cmp $a} ( keys( %DATA ) ) ) { 
		printDetails( $DATA{$key} );
	}
} else { 
	foreach $key ( ( keys( %DATA ) ) ) { 
		printDetails( $DATA{$key} );
	}
}
&htmlBottom;
exit;

sub printDetails {
	my($line) = shift;

	($fullFilename,$title,$date) = split( /<>/ , $line);
	
    print "<TR><TD><A HREF=\"$fullFilename\">$title</A></TD><TD ALIGN=\"Right\"><CODE>";
    print "$date</CODE></TD></TR>\n";
}
	
sub checkFiles {
    my($base) = shift;
    my($fullFilename);
    my(@lines);
    my($title);
    my($modtime);
	my($myexit);
	
    opendir(ROOT,$base);
    @lines = readdir(ROOT);
    closedir(ROOT);

    foreach (@lines) {
        next if /^\.|\.\.$/;

        $fullFilename = "$base/$_";

        if (-d $fullFilename) {
            if($subDir > 0) { checkFiles( $fullFilename); }
            next;
        }

        if (!($fullFilename =~ m/\.htm/i)) { next; }

        $modTime = (stat($fullFilename))[9];

		$myexit = "0";
        if ($modTime < $mytime) { next; }

        $title = "Untitled";

        open(FILE,$fullFilename);
        while( $line =  <FILE> ) {
            if ($line =~ m!<title>(.+)</title>!i) { $title = $1; }
			if ($line =~ m/<!-- nosearch -->/i) { $myexit = "1"; last; }
        }
        close(FILE);

		if ($myexit eq "1") { next; }

        $fullFilename =~ s/$FORM{'base'}//g;
        $fullFilename = "$FORM{'rbase'}$fullFilename";

        $date = localtime($modTime);
        $ndate = niceDate($date);
        $sdate = sortDate($date);
        
		$DATA{"$sdate$fullFilename"} = "$fullFilename<>$title<>$ndate";
    }
}

sub niceDate {
    my($date) = shift;
    my($myDate);

    $myDate = substr($date,0,3). " ". substr($date, 8,2)."/".substr($date,4,3)."/".substr($date,20,4);
    $myDate = "$myDate ".substr($date,11,8);
    
    $myDate =~ s/ /&nbsp;/gi;
    return $myDate;
}

sub parseForm {
    my($key,$value);
    my($buffer);
    my(@lines);
    my($line);

    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    if ($buffer eq "") { $buffer = $ENV{'QUERY_STRING'}; }

    @lines = split( /&/, $buffer);
    foreach $line (@lines) {
		chomp($line);
		chomp($line);
		chomp($line);
		chomp($line);
        ($key,$value) = split( /=/,$line);

        $key = lc($key);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
        $value =~ s/\n//g;
        $value =~ s/\r/ /g;
        $value =~ s/</&lt;/g;
        $value =~ s/>/&gt;/g;
        $FORM{$key} = $value;
    }
	if ($FORM{'uname'} ne "") {
		$FORM{'base'} = "/usr/people/patrol/premium/$FORM{'uname'}/User_html";
		$FORM{'rbase'} = "/~$FORM{'uname'}";
	}
}

sub myError {
   my($errmsg) = shift;

   print "Content-type: text/html\n\n";
   print "<HTML><HEAD><TITLE>whatschanged.pl - Error</TITLE></HEAD><BODY>\n";
   print "<H1>whatschanged.pl</H1>\n";
   print "The following error occured<P>\n";
   print "<LI>$errmsg";
   print "</BODY></HTML>\n";
   exit;
}

sub writeLog {
    my($site);

    $site = $ENV{'REMOTE_HOST'};
    if ($site eq "") { $site = $ENV{'REMOTE_ADDR'}; }

    if (!(-e "$FORM{'log'}" )) {
        open( OUTFILE,">$FORM{'log'}") or return;
        print OUTFILE "\"time\",\"remote site\"\n";
        close(OUTFILE);
    }

    open( OUTFILE,">>$FORM{'log'}") or return;
    print OUTFILE "\"" . localtime() . "\",\"$site\"\n";
    close( OUTFILE );
}

sub htmlTop {
	print "Content-type: text/html\n\n";
	print "<HTML><HEAD><TITLE>ı䶯 $FORM{'rbase'}</TITLE></HEAD>\n";
	&doBody;
	print "<CENTER><H1>ı䶯<BR>$FORM{'rbase'}</H1></CENTER><HR>\n";
	print "䶯ļб--";
	$date = localtime( $mytime );
	print niceDate($date) . "<P>\n";
	print "<TABLE WIDTH=\"100%\">\n";
	print "<TR><TH ALIGN=\"Left\">ĵ</TH><TH ALIGN=\"right\">ʱ</TH></TR>\n";
}

sub htmlBottom {
	$t2 = time();
	print "</TABLE>\n";
	print "<HR>\n<TABLE WIDTH=\"100%\"><TR>\n<TD WIDTH=\"33%\" ALIGN=\"Left\">";
	print "<FONT SIZE=2>Copyright &copy; 1998 <A HREF=\"http://oh.yeah.net\">Oh Yeah Net</A></FONT>";
	print "</TD>\n<TD ALIGN=\"center\"><FONT SIZE=2></FONT></TD>\n";
	print "<TD WIDTH=\"33%\" ALIGN=\"Right\"><FONT SIZE=2>ʱ: ";
	print $t2-$t1;
	print " ";
	if ($t2-$t1 == 1) { print "."; } else { print "."; }
	print "</FONT></TD>\n</TR></TABLE>\n";
	print "</BODY></HTML>\n";
}

sub doBody {
	my($line) = "<BODY";
	
	if ($FORM{'background'} ne "") { $line = "$line BACKGROUND=\"$FORM{'background'}\""; }
	if ($FORM{'bgcolor'   } ne "") { $line = "$line BGCOLOR=\"$FORM{'bgcolor'}\""; }
	if ($FORM{'text'      } ne "") { $line = "$line TEXT=\"$FORM{'text'}\""; }
	if ($FORM{'link'      } ne "") { $line = "$line LINK=\"$FORM{'link'}\""; }
	if ($FORM{'alink'     } ne "") { $line = "$line ALINK=\"$FORM{'alink'}\""; }
	if ($FORM{'vlink'     } ne "") { $line = "$line VLINK=\"$FORM{'vlink'}\""; }
	$line = "$line>\n";
	print $line;
}

sub sortDate { 
	my($date) = shift;
	my($myDate);
	
	$myDate = substr($date,20,4);
	
	if (lc(substr($date,4,3)) eq "jan") { $myDate = $myDate . "01"; }
	if (lc(substr($date,4,3)) eq "feb") { $myDate = $myDate . "02"; }
	if (lc(substr($date,4,3)) eq "mar") { $myDate = $myDate . "03"; }
	if (lc(substr($date,4,3)) eq "apr") { $myDate = $myDate . "04"; }
	if (lc(substr($date,4,3)) eq "may") { $myDate = $myDate . "05"; }
	if (lc(substr($date,4,3)) eq "jun") { $myDate = $myDate . "06"; }
	if (lc(substr($date,4,3)) eq "jul") { $myDate = $myDate . "07"; }
	if (lc(substr($date,4,3)) eq "aug") { $myDate = $myDate . "08"; }
	if (lc(substr($date,4,3)) eq "sep") { $myDate = $myDate . "09"; }
	if (lc(substr($date,4,3)) eq "oct") { $myDate = $myDate . "10"; }
	if (lc(substr($date,4,3)) eq "nov") { $myDate = $myDate . "11"; }
	if (lc(substr($date,4,3)) eq "dec") { $myDate = $myDate . "12"; }
	
	$myDate = $myDate . substr($date,8,2) . substr($date,11,8);
	$myDate =~ tr/ /0/;
	return $myDate;
}
